/**********************************************************************/
/*                                                                    */
/* Copyright (c) 2001 by Sun Microsystems, Inc.                       */
/* All rights reserved.                                               */
/*                                                                    */
/**********************************************************************/


/* $Date:   17 Nov 2003 13:31:24  $ */
/* $Modtime:   17 Nov 2003 13:22:20  $ */

/* $Workfile:   dfhaid.h  $ $Revision:   1.0  $ */

/*
 * $Log:   /builds/source/tmp/MTP8.0.0p7a/unikixsrc/devtools/compilers/clt/PVCS/dfhaid.h_v  $
 * 
 *    Rev 1.0   17 Nov 2003 13:31:24   unikix
 * New 8.0 archive
 * 
 *    Rev 1.0   19 Sep 2001 16:37:02   unikix
 * Initial 7.2
 * 
 *    Rev 1.0   30 Jan 2000 11:41:08   unikix
 * Initial 7.0
 * 
 *    Rev 1.0   15 Mar 1999 19:53:28   unikix
 * Initial 6.0
 * 
 *    Rev 1.0   13 May 1998 15:26:12   randyh
 * Initial revision.
 * 
 *    Rev 1.0   05/22/97 17:15:22   unikix
 */

/*
 * DESCRIPTION:
 *  This file contains all attention identifier (AID) constants.
 */

#if !defined(DFHAID_H)
#define DFHAID_H

/*
 *  OBJECT: Attention Identifiers - Defines for all AID keys.
 */

#define DFHNULL         0x2d    /* ('-')NULL field */   
#define DFHENTER	0x27	/* (''')ENTER key */
#define DFHCLEAR	0x5f	/* ('_')CLEAR key */
#define DFHCLRP		0x7c	/* ('|')Clear Partition */
#define DFHPEN		0x3d	/* ('=')SELECTOR PEN or CURSOR SELECT key */
#define DFHOPID		0x57	/* ('W')OPERID or MSR */
#define DFHMSRE		0x58	/* ('X')Extended (standard) MSR */
#define DFHSTRF		0x68	/* ('h')Structured field */
#define DFHTRIG		0x22	/* ('"')Trigger field    */
#define DFHPA1		0x25	/* ('%')PA1  key */
#define DFHPA2		0x3e	/* ('>')PA2  key */
#define DFHPA3		0x2c	/* (',')PA3  key */
#define DFHPF1		0x31	/* ('1')PF1  key */
#define DFHPF2		0x32	/* ('2')PF2  key */
#define DFHPF3		0x33	/* ('3')PF3  key */
#define DFHPF4		0x34	/* ('4')PF4  key */
#define DFHPF5		0x35	/* ('5')PF5  key */
#define DFHPF6		0x36	/* ('6')PF6  key */
#define DFHPF7		0x37	/* ('7')PF7  key */
#define DFHPF8		0x38	/* ('8')PF8  key */
#define DFHPF9		0x39	/* ('9')PF9  key */
#define DFHPF10		0x3a	/* (':')PF10 key */
#define DFHPF11		0x23	/* ('#')PF11 key */
#define DFHPF12		0x40	/* ('@')PF12 key */
#define DFHPF13		0x41	/* ('A')PF13 key */
#define DFHPF14		0x42	/* ('B')PF14 key */
#define DFHPF15		0x43	/* ('C')PF15 key */
#define DFHPF16		0x44	/* ('D')PF16 key */
#define DFHPF17		0x45	/* ('E')PF17 key */
#define DFHPF18		0x46	/* ('F')PF18 key */
#define DFHPF19		0x47	/* ('G')PF19 key */
#define DFHPF20		0x48	/* ('H')PF20 key */
#define DFHPF21		0x49	/* ('I')PF21 key */
#define DFHPF22		0x5b	/* ('[')PF22 key */
#define DFHPF23		0x2e	/* ('.')PF23 key */
#define DFHPF24		0x3c	/* ('<')PF24 key */

#endif


/* End of Module */

